import { StreamingReader } from '../../util/buffers/StreamingReader';
import { RespDecoder } from './RespDecoder';
export class RespStreamingDecoder {
    reader = new StreamingReader();
    decoder = new RespDecoder(this.reader);
    push(uint8) {
        this.reader.push(uint8);
    }
    read() {
        const reader = this.reader;
        if (reader.size() === 0)
            return undefined;
        const x = reader.x;
        try {
            const val = this.decoder.val();
            reader.consume();
            return val;
        }
        catch (error) {
            if (error instanceof RangeError) {
                reader.x = x;
                return undefined;
            }
            else
                throw error;
        }
    }
}
